//
// EmployeeAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class EmployeeAPI {
    /**

     - parameter department: (query)  
     - parameter userId: (query)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func apiEmployeeGetEmployeeGet(department: String, userId: Int, completion: @escaping ((_ data: UserResponseModelArrayResponseModel?,_ error: Error?) -> Void)) {
        apiEmployeeGetEmployeeGetWithRequestBuilder(department: department, userId: userId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     - GET /api/Employee/GetEmployee
     - 

     - examples: [{contentType=application/json, example={
  "Data" : [ {
    "Email" : "Email",
    "Joining" : "2000-01-23T04:56:07.000+00:00",
    "Id" : "Id",
    "Name" : "Name"
  }, {
    "Email" : "Email",
    "Joining" : "2000-01-23T04:56:07.000+00:00",
    "Id" : "Id",
    "Name" : "Name"
  } ],
  "ErrorMessage" : "ErrorMessage"
}}]
     - parameter department: (query)  
     - parameter userId: (query)  

     - returns: RequestBuilder<UserResponseModelArrayResponseModel> 
     */
    open class func apiEmployeeGetEmployeeGetWithRequestBuilder(department: String, userId: Int) -> RequestBuilder<UserResponseModelArrayResponseModel> {
        let path = "/api/Employee/GetEmployee"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "Department": department, 
                        "UserId": userId.encodeToJSON()
        ])


        let requestBuilder: RequestBuilder<UserResponseModelArrayResponseModel>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**

     - parameter body: (body)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func apiEmployeeGetEmployeePayrollPost(body: EmployeePayrollRequest? = nil, completion: @escaping ((_ data: EmployeePayrollResponseArrayResponseModel?,_ error: Error?) -> Void)) {
        apiEmployeeGetEmployeePayrollPostWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     - POST /api/Employee/GetEmployeePayroll
     - 

     - examples: [{contentType=application/json, example={
  "Data" : [ {
    "CurrencyCode" : "CurrencyCode",
    "WeeklyRate" : 6.027456183070403,
    "EmployeeId" : 0,
    "CountryCode" : "CountryCode",
    "Name" : "Name"
  }, {
    "CurrencyCode" : "CurrencyCode",
    "WeeklyRate" : 6.027456183070403,
    "EmployeeId" : 0,
    "CountryCode" : "CountryCode",
    "Name" : "Name"
  } ],
  "ErrorMessage" : "ErrorMessage"
}}]
     - parameter body: (body)  (optional)

     - returns: RequestBuilder<EmployeePayrollResponseArrayResponseModel> 
     */
    open class func apiEmployeeGetEmployeePayrollPostWithRequestBuilder(body: EmployeePayrollRequest? = nil) -> RequestBuilder<EmployeePayrollResponseArrayResponseModel> {
        let path = "/api/Employee/GetEmployeePayroll"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<EmployeePayrollResponseArrayResponseModel>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**

     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func apiEmployeeGetTokenGet(completion: @escaping ((_ data: AuthResponseResponseModel?,_ error: Error?) -> Void)) {
        apiEmployeeGetTokenGetWithRequestBuilder().execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     - GET /api/Employee/GetToken
     - 

     - examples: [{contentType=application/json, example={
  "Data" : {
    "Token" : "Token"
  },
  "ErrorMessage" : "ErrorMessage"
}}]

     - returns: RequestBuilder<AuthResponseResponseModel> 
     */
    open class func apiEmployeeGetTokenGetWithRequestBuilder() -> RequestBuilder<AuthResponseResponseModel> {
        let path = "/api/Employee/GetToken"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<AuthResponseResponseModel>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**

     - parameter name: (form)  (optional)
     - parameter lastName: (form)  (optional)
     - parameter dateOfJoining: (form)  (optional)
     - parameter dateOfBirth: (form)  (optional)
     - parameter gender: (form)  (optional)
     - parameter departmentName: (form)  (optional)
     - parameter managerName: (form)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func apiEmployeeMultiPartCodeChallengePost(name: String? = nil, lastName: String? = nil, dateOfJoining: Date? = nil, dateOfBirth: Date? = nil, gender: String? = nil, departmentName: String? = nil, managerName: String? = nil, completion: @escaping ((_ data: EmployeeResponseResponseModel?,_ error: Error?) -> Void)) {
        apiEmployeeMultiPartCodeChallengePostWithRequestBuilder(name: name, lastName: lastName, dateOfJoining: dateOfJoining, dateOfBirth: dateOfBirth, gender: gender, departmentName: departmentName, managerName: managerName).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     - POST /api/Employee/MultiPartCodeChallenge
     - 

     - examples: [{contentType=application/json, example={
  "Data" : {
    "Message" : "Message"
  },
  "ErrorMessage" : "ErrorMessage"
}}]
     - parameter name: (form)  (optional)
     - parameter lastName: (form)  (optional)
     - parameter dateOfJoining: (form)  (optional)
     - parameter dateOfBirth: (form)  (optional)
     - parameter gender: (form)  (optional)
     - parameter departmentName: (form)  (optional)
     - parameter managerName: (form)  (optional)

     - returns: RequestBuilder<EmployeeResponseResponseModel> 
     */
    open class func apiEmployeeMultiPartCodeChallengePostWithRequestBuilder(name: String? = nil, lastName: String? = nil, dateOfJoining: Date? = nil, dateOfBirth: Date? = nil, gender: String? = nil, departmentName: String? = nil, managerName: String? = nil) -> RequestBuilder<EmployeeResponseResponseModel> {
        let path = "/api/Employee/MultiPartCodeChallenge"
        let URLString = SwaggerClientAPI.basePath + path
        let formParams: [String:Any?] = [
                "Name": name,
                "LastName": lastName,
                "DateOfJoining": dateOfJoining?.encodeToJSON(),
                "DateOfBirth": dateOfBirth?.encodeToJSON(),
                "Gender": gender,
                "DepartmentName": departmentName,
                "ManagerName": managerName
        ]

        let nonNullParameters = APIHelper.rejectNil(formParams)
        let parameters = APIHelper.convertBoolToString(nonNullParameters)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<EmployeeResponseResponseModel>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
}
